import javax.swing.*;
import java.awt.*;   
import java.awt.event.*;
   
public class app10 extends JFrame {
  public static void main( String args[] ) {
    JFrame frame = new app10();
    frame.setSize( 400, 280 );
    frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    frame.setTitle( "..." );
    frame.setContentPane( new Tekenpaneel() );
    frame.setVisible( true );
  }
}


class Tekenpaneel extends JPanel {
  private Rechthoek rechthoek1, rechthoek2;
  private JButton knop, knop2, knop3, knop4;
  
  public Tekenpaneel() {
    setBackground( Color.WHITE );

    rechthoek1 = new Rechthoek( Color.BLUE, 100, 100, 40, 20 );
    rechthoek2 = new Rechthoek( Color.RED,  180, 100, 20, 40 );
    knop = new JButton( "Verplaats" );
    knop.addActionListener( new KnopHandler() );
    add( knop );
    knop2 = new JButton( "Breng terug" );
    knop2.addActionListener( new KnopHandler2() );
    add( knop2 );
    knop3 = new JButton( "Uit elkaar" );
    knop3.addActionListener( new KnopHandler3() );
    add( knop3 );
    knop4 = new JButton( "Terug" );
    knop4.addActionListener( new KnopHandler4() );
    add( knop4 );
  }

  public void paintComponent( Graphics g ) {
    super.paintComponent( g );
    rechthoek1.teken( g );
    rechthoek2.teken( g );
  }

  class KnopHandler implements ActionListener {
    public void actionPerformed( ActionEvent e ) {
      rechthoek1.naarRechts();
      rechthoek2.naarLinks();
      repaint();
    }
  }

  class KnopHandler2 implements ActionListener {
    public void actionPerformed( ActionEvent e ) {
      rechthoek1.naarLinks();
      rechthoek2.naarRechts();
      repaint();
    }
  }

  class KnopHandler3 implements ActionListener {
    public void actionPerformed( ActionEvent e ) {
      rechthoek1.naarBoven();
      rechthoek2.naarBeneden();
      repaint();
    }
  }

  class KnopHandler4 implements ActionListener {
    public void actionPerformed( ActionEvent e ) {
      rechthoek1.naarBeneden();
      rechthoek2.naarBoven();
      repaint();
    }
  }
}

class Rechthoek {
  private Color kleur;
  private int x, y;
  private int breedte, hoogte;

  public Rechthoek( Color kleur, int x, int y, int breedte, int hoogte ) {
    this.kleur = kleur;
    this.x = x;
    this.y = y;
    this.breedte = breedte;
    this.hoogte = hoogte;
  }

  public void naarLinks() {
    x -= 4;
  }

  public void naarRechts() {
    x += 4;
  }
  
  public void naarBeneden() {
    y += 4;
  }
  public void naarBoven() {
    y -= 4;
  }

  public void teken( Graphics pen ) {
    pen.setColor( kleur );
    pen.fillRect( x, y, breedte, hoogte );
  }
}